"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.togglePosition = void 0;
const gsap_1 = __importDefault(require("gsap"));
function togglePosition(top, bottom, options) {
    var _a, _b;
    let duration = (_a = options === null || options === void 0 ? void 0 : options.duration) !== null && _a !== void 0 ? _a : 0.5;
    let ease = (_b = options === null || options === void 0 ? void 0 : options.ease) !== null && _b !== void 0 ? _b : "Power1.easeOut";
    return new Promise((resolve, reject) => {
        try {
            if (top.getBoundingClientRect().y > bottom.getBoundingClientRect().y) {
                let tmp = top;
                top = bottom;
                bottom = tmp;
            }
            const topY = top.getBoundingClientRect().y;
            const bottomY = bottom.getBoundingClientRect().y;
            const shift = bottomY - topY;
            gsap_1.default.defaults({ duration, ease });
            gsap_1.default.to(top, { y: shift });
            gsap_1.default.to(bottom, { y: -shift }).eventCallback("onComplete", () => {
                const parent = top.parentElement;
                parent === null || parent === void 0 ? void 0 : parent.removeChild(bottom);
                parent === null || parent === void 0 ? void 0 : parent.insertBefore(bottom, top);
                gsap_1.default.set(top, { y: 0 });
                gsap_1.default.set(bottom, { y: 0 });
                if (options === null || options === void 0 ? void 0 : options.callback) {
                    options.callback();
                }
                resolve();
            });
        }
        catch (error) {
            reject();
        }
    });
}
exports.togglePosition = togglePosition;
